3
     �_’I|¥‰ÓMjqØ‚¦ð¬÷À¿      File not found.
  *   ˆl–Ü4ý( ©³( 	Å€fàB¦-ÿÂƒ!w_†I|¥�+ÂÁ 	    /* SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note */
#ifndef _UAPI_MPLS_H
#define _UAPI_MPLS_H

#include <linux/types.h>
#include <asm/byteorder.h>

/* Reference: RFC 5462, RFC 3032
 *
 *  0                   1                   2                   3
 *  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 * |                Label                  | TC  |S|       TTL     |
 * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 *
 *	Label:  Label Value, 20 bits
 *	TC:     Traffic Class field, 3 bits
 *	S:      Bottom of Stack, 1 bit
 *	TTL:    Time to Live, 8 bits
 */

struct mpls_label {
	__be32 entry;
};

#define MPLS_LS_LABEL_MASK      0xFFFFF000
#define MPLS_LS_LABEL_SHIFT     12
#define MPLS_LS_TC_MASK         0x00000E00
#define MPLS_LS_TC_SHIFT        9
#define MPLS_LS_S_MASK          0x00000100
#define MPLS_LS_S_SHIFT         8
#define MPLS_LS_TTL_MASK        0x000000FF
#define MPLS_LS_TTL_SHIFT       0

/* Reserved labels */
#define MPLS_LABEL_IPV4NULL		0 /* RFC3032 */
#define MPLS_LABEL_RTALERT		1 /* RFC3032 */
#define MPLS_LABEL_IPV6NULL		2 /* RFC3032 */
#define MPLS_LABEL_IMPLNULL		3 /* RFC3032 */
#define MPLS_LABEL_ENTROPY		7 /* RFC6790 */
#define MPLS_LABEL_GAL			13 /* RFC5586 */
#define MPLS_LABEL_OAMALERT		14 /* RFC3429 */
#define MPLS_LABEL_EXTENSION		15 /* RFC7274 */

#define MPLS_LABEL_FIRST_UNRESERVED	16 /* RFC3032 */

/* These are embedded into IFLA_STATS_AF_SPEC:
 * [IFLA_STATS_AF_SPEC]
 * -> [AF_MPLS]
 *    -> [MPLS_STATS_xxx]
 *
 * Attributes:
 * [MPLS_STATS_LINK] = {
 *     struct mpls_link_stats
 * }
 */
enum {
	MPLS_STATS_UNSPEC, /* also used as 64bit pad attribute */
	MPLS_STATS_LINK,
	__MPLS_STATS_MAX,
};

#define MPLS_STATS_MAX (__MPLS_STATS_MAX - 1)

struct mpls_link_stats {
	__u64	rx_packets;		/* total packets received	*/
	__u64	tx_packets;		/* total packets transmitted	*/
	__u64	rx_bytes;		/* total bytes received		*/
	__u64	tx_bytes;		/* total bytes transmitted	*/
	__u64	rx_errors;		/* bad packets received		*/
	__u64	tx_errors;		/* packet transmit problems	*/
	__u64	rx_dropped;		/* packet dropped on receive	*/
	__u64	tx_dropped;		/* packet dropped on transmit	*/
	__u64	rx_noroute;		/* no route for packet dest	*/
};

#endif /* _UAPI_MPLS_H */
     ˆ¿ÃƒiÇÃ¾ÂÁ S    /* SPDX-License-Identifier: BSD-3-Clause OR GPL-2.0 */
/* Copyright (c) 2018 Mellanox Technologies. All rights reserved */

#undef TRACE_SYSTEM
#define TRACE_SYSTEM objagg

#if !defined(__TRACE_OBJAGG_H) || defined(TRACE_HEADER_MULTI_READ)
#define __TRACE_OBJAGG_H

#include <linux/tracepoint.h>

struct objagg;
struct objagg_obj;

TRACE_EVENT(objagg_create,
	TP_PROTO(const struct objagg *objagg),

	TP_ARGS(objagg),

	TP_STRUCT__entry(
		__field(const void *, objagg)
	),

	TP_fast_assign(
		__entry->objagg = objagg;
	),

	TP_printk("objagg %p", __entry->objagg)
);

TRACE_EVENT(objagg_destroy,
	TP_PROTO(const struct objagg *objagg),

	TP_ARGS(objagg),

	TP_STRUCT__entry(
		__field(const void *, objagg)
	),

	TP_fast_assign(
		__entry->objagg = objagg;
	),

	TP_printk("objagg %p", __entry->objagg)
);

TRACE_EVENT(objagg_obj_create,
	TP_PROTO(const struct objagg *objagg,
		 const struct objagg_obj *obj),

	TP_ARGS(objagg, obj),

	TP_STRUCT__entry(
		__field(const void *, objagg)
		__field(const void *, obj)
	),

	TP_fast_assign(
		__entry->objagg = objagg;
		__entry->obj = obj;
	),

	TP_printk("objagg %p, obj %p", __entry->objagg, __entry->obj)
);

TRACE_EVENT(objagg_obj_destroy,
	TP_PROTO(const struct objagg *objagg,
		 const struct objagg_obj *obj),

	TP_ARGS(objagg, obj),

	TP_STRUCT__entry(
		__field(const void *, objagg)
		__field(const void *, obj)
	),

	TP_fast_assign(
		__entry->objagg = objagg;
		__entry->obj = obj;
	),

	TP_printk("objagg %p, obj %p", __entry->objagg, __entry->obj)
);

TRACE_EVENT(objagg_obj_get,
	TP_PROTO(const struct objagg *objagg,
		 const struct objagg_obj *obj,
		 unsigned in